<?php
/*------------------------------------------------------------------------
# smartgallery.php - SmartGallery (plugin)
# ------------------------------------------------------------------------
# version		1.0.0
# author    	Top Position
# copyright 	Copyright (c) 2011 Top Position	 All rights reserved.
# @license 		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites 	http://posicionamientoenbuscadoreswebseo.es/
-------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.plugin.plugin' );

class plgContentSmartGallery extends JPlugin {
	
	public function onContentPrepare($context, &$article, &$params, $limitstart) {
		
		//de momento solo permitimos la vista articulo
		// ##pendiente: admitir en otro tipo de contenidos, vista categoras y frontpage##
		if($context!='com_content.article') return;
		if(!isset($article->text) || $article->text=='') return;
		
		//vemos las ocurrencias en el texto y si no hay nos vamos
		// ##pendiente: cambiar el modo de introducir el codigo del pllugin##
		preg_match_all("/\{smartgallery([^}]*)\}/i", $article->text, $ocurrencias);
		if(!isset($ocurrencias[0]) && is_array($ocurrencias[0]) || !isset($ocurrencias[1]) && is_array($ocurrencias[1])) return;
	
		//importamos los archivos necesarios del framework de joomla para el manejo de carpetas y archivos
	
		jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');

		$contador = 0;
			 
		//mostramos la galeria de las imagenes que estan en el path
		foreach ($ocurrencias[1] as $k => $ocurrencia) {
		
			$width = 0;
			$height = 0;
			$folder = '';
			$title = '';
			
			$options = explode('#', trim($ocurrencia));
			
			$contador++;
			
			foreach($options As $option){
			
				$keyval = explode(':',trim($option), 2);
				if(count($keyval) == 2){
					$value = trim($keyval[1]);
					switch(strtolower(trim($keyval[0]))){
						case 'width':
							$width = $value;
							break;
						case 'height':
							$height = $value;
							break;
						case 'folder':
							$folder = $value;
							break;
						case 'title':
							$title = $value;
							break;
						
					}
				}
			}
			
			// ##pendiente: admitir mas de una galeria##
			$ruta_galeria = JPATH_SITE.'/'.$folder;
						
			$carpeta = JFolder::files($ruta_galeria);
			$siteUrl  = JURI::base(true);
			if(!$carpeta) return; // si la carpeta de la galeria no existe nos volvemos
			
			$extensiones = array('jpg','jpeg','gif','png'); //extensiones permitidas
			
			//si el plugin est en modo mostrar imagen
			if(JRequest::getInt('smartplgsw',0)==$contador&&JRequest::getVar('smartplgimg', '')) {                                         
				ob_end_clean();
				
				$nombreimagen = JRequest::getVar('smartplgimg', '');
				$imagen = $ruta_galeria.'/'.JRequest::getVar('smartplgimg', '');
				
				if(!JFolder::exists($ruta_galeria . DS . 'smartgallery')) JFolder::create($ruta_galeria . DS . 'smartgallery');
				if(!JFile::exists($ruta_galeria . DS . 'smartgallery'. DS . 'index.html')) JFile::write($ruta_galeria . DS . 'smartgallery'. DS . 'index.html', $def = '');
				$default_folder = $ruta_galeria . DS . 'smartgallery'. DS;	
				
				//die($imagen);
				
				$imagen_ = pathinfo($imagen);
				if(!array_key_exists('extension', $imagen_) || !in_array(strtolower($imagen_['extension']),$extensiones)) return;
				
				$mimetype = $imagen_['extension'];
				
				//die($ruta_galeria . DS . 'smartgallery'. DS . 'thumb_'.$nombreimagen);
				
					//vamos a ver si existe la imagen en el cache
				if(!JFile::exists($ruta_galeria . DS . 'smartgallery'. DS . 'thumb_'.$nombreimagen)) {
	
					switch($mimetype) {
						
						case 'jpg': $original = imagecreatefromjpeg($imagen);
									$ancho = imagesx($original);
									$alto = imagesy($original);
									if($width==0&&$height) $width =  (int) (($ancho/$alto) * $height);
									if($width&&$height==0) $height = (int) (($alto*$width)/$ancho);
									if($width==0&&$height==0) {
										$width = $ancho;
										$height = $alto;
									}
									$thumb = imagecreatetruecolor($width,$height); 																										
									imagecopyresampled($thumb,$original,0,0,0,0,$width,$height,$ancho,$alto);
									imagejpeg($thumb,$default_folder.'thumb_'.$nombreimagen,90);
									break;
						case 'gif': 
									$original = imagecreatefromgif($imagen);
									$ancho = imagesx($original);
									$alto = imagesy($original);
									if($width==0&&$height) $width =  (int) (($ancho/$alto) * $height);
									if($width&&$height==0) $height = (int) (($alto*$width)/$ancho);
									if($width==0&&$height==0) {
										$width = $ancho;
										$height = $alto;
									}
									$thumb = imagecreatetruecolor($width,$height); 																		
									imagecopyresampled($thumb,$original,0,0,0,0,$width,$height,$ancho,$alto);
									imagegif($thumb,$default_folder.'thumb_'.$nombreimagen); 
									break;
						case 'png': 
									$original = imagecreatefrompng($imagen);
									$ancho = imagesx($original);
									$alto = imagesy($original);
									if($width==0&&$height) $width =  (int) (($ancho/$alto) * $height);
									if($width&&$height==0) $height = (int) (($alto*$width)/$ancho);
									if($width==0&&$height==0) {
										$width = $ancho;
										$height = $alto;
									}
									$thumb = imagecreatetruecolor($width,$height); 
									imagecopyresampled($thumb,$original,0,0,0,0,$width,$height,$ancho,$alto);
									imagepng($thumb,$default_folder.'thumb_'.$nombreimagen,9); 
									break;
					}
	
				}
								
				switch($mimetype) {
					case 'jpg': header('Content-Type: ' . image_type_to_mime_type(IMAGETYPE_JPEG)); break;
					case 'gif': header('Content-Type: ' . image_type_to_mime_type(IMAGETYPE_GIF)); break;
					case 'png': header('Content-Type: ' . image_type_to_mime_type(IMAGETYPE_PNG)); break;
				}
				
				@readfile($default_folder.'thumb_'.$nombreimagen);
				die();
			}
			
			//creamos el array de la galeria
			$galeria = array(); 
			
			//para cada elemento en ese directorio
			foreach($carpeta as $imagen){
				//si el archivo tiene extension y es de las permitidas lo aadimos a la galera
				$imagen_ = pathinfo($imagen);
				if(array_key_exists('extension', $imagen_) && in_array(strtolower($imagen_['extension']),$extensiones)) $galeria[] = $imagen;
			}
			
			//si no hay elementos en ese path regresamos
			if(count($galeria)==0) return;
			
			//procedemos a incluir los scripts necesario para el lightbox
			$document = &JFactory::getDocument();
		
			if($contador==1) {
		
				//Si queremos incluir el mootools-more-1.3.2.1-assets.js		
				if($this->params->get('mootools',1)) $document->addCustomTag('
	<script src="/plugins/content/smartgallery/library/cerabox/mootools-more-1.3.2.1-assets.js" type="text/javascript"></script>
	');
				//incluimos los estilos
				//##pendiente: incluir opcin para no incluir estilos##
				if($this->params->get('css',1)) $document->addCustomTag('
	<link rel="stylesheet" href="/plugins/content/smartgallery/library/smartgallery.css" type="text/css" />');
				
				//incluimos los scripts de cerabox
				$document->addCustomTag('
	<script src="/plugins/content/smartgallery/library/cerabox/cerabox.min.js" type="text/javascript"></script>
	<script type="text/javascript">'."
		window.addEvent('domready', function(){
			var box = new CeraBox();
			box.addItems('.smartgallery_holder a', {
			animation: 'ease',
			displayTitle: true,
			displayOverlay: true,
			loaderAtItem: true
			});
		});
	</script>
	");			
			}
	
			//cogemos la url en la que estamos y montamos la ruta para pedir la imagen
			$url = JURI::getInstance()->toString();
			$url = JRoute::_($url.(strstr($url,'?') !== false ? '&' : '?')).'smartplgsw='.$contador.'&amp;smartplgimg=';

			//montamos el cdigo de la galera
			$text = '<div class="smartgallery_holder">';
			if($title) $text .= '<div class="smart_gallery_title"><h3>'.$title.'</h3></div>';
			$text .= '
				<div class="image-holder">';
			foreach($galeria as $k=>$nombre_imagen){
				$text .= '<a href="'.$siteUrl.'/'.$folder.'/'.$nombre_imagen.'" class="cerabox" ><img src="'.$url.urlencode($nombre_imagen).'" alt="Click to enlarge" /></a>';		
			}
			$text .= '
					<div class="clears"></div>
				</div>
			</div>';
			
			$article->text .= $text;
					
		} 
		
		foreach ($ocurrencias[0] as $k=>$ocurrencia_) {
			$article->text = str_replace($ocurrencia_, '', $article->text);
		}
		
		if($this->params->get('credits',1)) $article->text .= '<div class="firma">Smart Gallery by <a href="http://posicionamientoenbuscadoreswebseo.es/" title="posicionamiento en buscadores">posicionamiento en buscadores</a></div>';	
	}
	
	function CalculaProporcion($ancho_original, $alto_original, $ancho_thumb, $alto_thumb) {
		
	}
	
}